<?php

header("Access-Control-Allow-Origin: *");
// Allow specific methods
header("Access-Control-Allow-Methods: POST, OPTIONS");
// Allow specific headers
header("Access-Control-Allow-Headers: Content-Type, Authorization");

// Respond to preflight requests (OPTIONS)
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
    // Send a 200 response and exit
    http_response_code(200);
    exit();
}

function getZohoAccessToken(){

    global $zohoRefreshToken, $zohoClientID, $zohoClientSecret, $zohoTokenExpiryTime, $zohoAccessToken;

    // Check if the token is valid
    if ($zohoAccessToken && time() < $zohoTokenExpiryTime) {
        return $zohoAccessToken;
    }

    // Regenerate the token
    $url = "https://accounts.zoho.com/oauth/v2/token?refresh_token=$zohoRefreshToken&client_id=$zohoClientID&client_secret=$zohoClientSecret&grant_type=refresh_token";
    $ch = curl_init();
    curl_setopt_array($ch, array(
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
    ));
    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);
    if (isset($responseData['access_token'])) {
        $zohoAccessToken = $responseData['access_token'];
        $zohoTokenExpiryTime = time() + $responseData['expires_in'] - 60; // 60 seconds buffer
        return $zohoAccessToken;
    } else {
        throw new Exception("Unable to fetch Zoho access token: " . $response);
    }
}


$zohoRefreshToken = "1000.98015694c4f529aae9fe71d359b83c6d.363bbcdb7a901c5b5b7a057552281be3";
$zohoClientID = "1000.SA0YBZ4XOB1ZUOROT59UOWL0PJFZFQ";
$zohoClientSecret = "718f21033fcacd7fe737d6060ab13df7a7d94ea475";
$zohoTokenExpiryTime = 0;
$zohoAccessToken = "";
//
$url = "https://idcs-64fc1a19cfef4fa98acc4022d9c1731a.identity.oraclecloud.com/oauth2/v1/token";
$clientId = "2d9906224ed94b35b8b97b0115723a59";
$clientSecret = "712a1f2f-905f-4eea-aa62-2313d85c0f60";
$clientString = base64_encode($clientId.":".$clientSecret);
$headers = ["Authorization: Basic " . $clientString];
$bodyMap = [
"grant_type" => "client_credentials",
"scope" => "https://A0E1EF63A50849DE90A80AEE5F67DEDC.integration.ocp.oraclecloud.com:443urn:opc:resource:consumer::all"
];

$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, $url);
curl_setopt($curl, CURLOPT_POST, true);
curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($bodyMap));
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
$response = curl_exec($curl);
curl_close($curl);

$accessToken = json_decode($response)->access_token;

echo $accessToken;
exit;
$date = date("Y-m-d");
$url = "https://test-oic-axcgh2w0sal9-dx.integration.me-dubai-1.ocp.oraclecloud.com/ic/api/integration/v1/flows/rest/MAINTE_ASSERT_MASTER_RECORD_SYNC/1.0/maintenacerecord?P_Last_Date=".$date;
$headers = ["Authorization: Bearer " . $accessToken];

$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, $url);
curl_setopt($curl, CURLOPT_HTTPGET, true);
curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
$response = curl_exec($curl);
curl_close($curl);

echo "<pre>";

$assetRec = json_decode($response)->Assert_record;
$locationArray = array();
$categoryArray = array();
$companyArray = array();

//Generate Zoho Token
$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => $URL,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
));

$response = curl_exec($curl);
curl_close($curl);
$accessToken = json_decode($response, true)['access_token'];
$counter = 0;
$creatorLog = [];

foreach ($assetRec as $rec){
	//First check if item exists
	$criteria = "Vehicle_number == \"".$rec->ASSET_NUMBER."\"";
	$url = "https://www.zohoapis.com/creator/v2.1/data/adminzoho_mawaridfs/fleet-management-system/report/All_Vehicle_Masters?criteria="
	.urlencode($criteria);
	$zohoAccessToken = getZohoAccessToken();
	$authorization = "Zoho-oauthtoken ".$zohoAccessToken;

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HTTPGET, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$headers = [
	    "Authorization: $authorization",
	];
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	$response = curl_exec($ch);
	echo $response;
	curl_close($ch);
	$jsonRes = json_decode($response, true);
	if($jsonRes["code"] == "3000"){
		//Item Exists
		continue;
	}

	if(array_key_exists($rec->ASSET_GROUP, $categoryArray)){
		$category = $categoryArray[$rec->ASSET_GROUP];
	}
	else{
		$criteria = "Category_Name == \"".$rec->ASSET_GROUP."\"";
		$url = "https://www.zohoapis.com/creator/v2.1/data/adminzoho_mawaridfs/fleet-management-system/report/All_Vehicle_Categories?criteria="
		.urlencode($criteria);
		$zohoAccessToken = getZohoAccessToken();
		$authorization = "Zoho-oauthtoken ".$zohoAccessToken;

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HTTPGET, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$headers = [
		    "Authorization: $authorization",
		];
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($ch);
		curl_close($ch);
		$jsonRes = json_decode($response, true);
		if($jsonRes["code"] == "9280"){
			//create new recrod
			$url = "https://www.zohoapis.com/creator/v2.1/data/a
			$zohoAccessToken = getZohoAccessToken();dminzoho_mawaridfs/fleet-management-system/form/Vehicle_Category";
			$authorization = "Zoho-oauthtoken ".$zohoAccessToken;
			$inputData = [
				"data" => [
					"Category_Name" => $rec->ASSET_GROUP
				]
			];
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$headers = [
			    "Authorization: $authorization",
			];
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($inputData));
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($ch);
			curl_close($ch);
			$addResp = json_decode($response, true);
			$category = $addResp['data']['ID'];
			$categoryArray[$rec->ASSET_GROUP] = $category;
			echo $category;
		}
		else if($jsonRes["code"] == "3000"){
			$category = $jsonRes['data'][0]['ID'];
			$categoryArray[$rec->ASSET_GROUP] = $category;
		}
	}
	if(array_key_exists($rec->LOCATION_DESCRIPTION, $locationArray)){
		$category = $locationArray[$rec->LOCATION_DESCRIPTION];
	}
	else{
		$criteria = "Division == \"".$rec->LOCATION_DESCRIPTION."\"";
		$url = "https://www.zohoapis.com/creator/v2.1/data/adminzoho_mawaridfs/fleet-management-system/report/All_Divisions?criteria="
		.urlencode($criteria);
		$zohoAccessToken = getZohoAccessToken();
		$authorization = "Zoho-oauthtoken ".$zohoAccessToken;

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HTTPGET, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$headers = [
		    "Authorization: $authorization",
		];
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($ch);
		curl_close($ch);
		$jsonRes = json_decode($response, true);
		if($jsonRes["code"] == "9280"){
			//create new recrod
			$url = "https://www.zohoapis.com/creator/v2.1/data/a
			$zohoAccessToken = getZohoAccessToken();dminzoho_mawaridfs/fleet-management-system/form/Division";
			$authorization = "Zoho-oauthtoken ".$zohoAccessToken;
			$inputData = [
				"data" => [
					"Division" => $rec->LOCATION_DESCRIPTION
				]
			];
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$headers = [
			    "Authorization: $authorization",
			];
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($inputData));
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($ch);
			curl_close($ch);
			$addResp = json_decode($response, true);
			$location = $addResp['data']['ID'];
			$locationArray[$rec->LOCATION_DESCRIPTION] = $location;
		}
		else if($jsonRes["code"] == "3000"){
			$location = $jsonRes['data'][0]['ID'];
			$locationArray[$rec->LOCATION_DESCRIPTION] = $location;
		}
	}
	if(array_key_exists($rec->LICENCE_OWNER, $companyArray)){
		$company = $companyArray[$rec->LICENCE_OWNER];
	}
	else{
		$criteria = "Company == \"".$rec->LICENCE_OWNER."\"";
		$url = "https://www.zohoapis.com/creator/v2.1/data/adminzoho_mawaridfs/fleet-management-system/report/All_Companies?criteria="
		.urlencode($criteria);
		$zohoAccessToken = getZohoAccessToken();
		$authorization = "Zoho-oauthtoken ".$zohoAccessToken;

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HTTPGET, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$headers = [
		    "Authorization: $authorization",
		];
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($ch);
		curl_close($ch);
		$jsonRes = json_decode($response, true);
		if($jsonRes["code"] == "9280"){
			//create new recrod
			$url = "https://www.zohoapis.com/creator/v2.1/data/a
			$zohoAccessToken = getZohoAccessToken();dminzoho_mawaridfs/fleet-management-system/form/Company";
			$authorization = "Zoho-oauthtoken ".$zohoAccessToken;
			$inputData = [
				"data" => [
					"Company" => $rec->LICENCE_OWNER
				]
			];
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$headers = [
			    "Authorization: $authorization",
			];
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($inputData));
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($ch);
			curl_close($ch);
			$addResp = json_decode($response, true);
			$company = $addResp['data']['ID'];
			$companyArray[$rec->LICENCE_OWNER] = $company;
		}
		else if($jsonRes["code"] == "3000"){
			$company = $jsonRes['data'][0]['ID'];
			$companyArray[$rec->LICENCE_OWNER] = $company;
		}
	}
	$Logdata = [
		"Vehicle_number"=>$rec->ASSET_NUMBER,
		"Asset_Status"=>$rec->ASSET_STATUS,
		"Vehicle_Description"=>$rec->ASSET_DESCRIPTION,
		"Division"=>$location,
		"Company"=>$company,
		"Vehicle_Category"=>$category,
		"Finance_Asset_Number"=>$rec->FA_ASSET_NUMBER,
		"Manufacturing_Year"=>$rec->YEAR_OF_MANUFACTURE,
		"Engine_number"=>$rec->ENGINE_NUMBER,
		"Capacity"=>$rec->CAPACITY,
		"Chassis_number"=>$rec->CHASSIS,
		"Vehicle_Year_Model"=>$rec->MODEL,
		"Plate_Number"=>$rec->PLATE_NUMBER,
		"Brand"=>$rec->BRAND,
		"Type_field"=>$rec->TYPE,
		"Status"=> "New Asset",
	];
	$creatorLog[] = $Logdata;
	$counter++;
	if($counter == 50){
		$counter = 0;
		$Payload = ["data"=> $creatorLog];
        $jsonPayload = json_encode($Payload);
        $url = "https://www.zohoapis.com/creator/v2.1/data/adminzoho_mawaridfs/fleet-management-system/form/Vehicle_Master";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$zohoAccessToken = getZohoAccessToken();
		$authorization = "Zoho-oauthtoken ".$zohoAccessToken;
		$headers = [
		    "Authorization: $authorization",
		];
		curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonPayload);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($ch);
		curl_close($ch);
		echo $response."<br>";
		$creatorLog = [];
	}
}
$Payload = ["data"=> $creatorLog];
$jsonPayload = json_encode($Payload);
$url = "https://www.zohoapis.com/creator/v2.1/data/adminzoho_mawaridfs/fleet-management-system/form/Vehicle_Master";
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$zohoAccessToken = getZohoAccessToken();
$authorization = "Zoho-oauthtoken ".$zohoAccessToken;
$headers = [
    "Authorization: $authorization",
];
curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonPayload);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
$response = curl_exec($ch);
curl_close($ch);
echo $response."<br>";

?>